import { select, geoMercator, geoPath, zoom } from 'd3';
const svg = select('svg');
const transitionDuration = 500;
const width = document.body.clientWidth;
const height = document.body.clientHeight;
let active = d3.select(null);
svg.attr('width', width).attr('height', height)
const g = svg.append('g');
const mercator = geoMercator().scale(30000).translate([width/2, height/2]).center([73,19.7]);
const pathGenerator = geoPath().projection(mercator);
//Zoom
  let zzoom = d3.zoom().on("zoom", zoomed);

  function zoomed() {
  // g.style("stroke-width", 1.5 / d3.event.transform.k + "px");
  g.attr("transform", d3.event.transform); // updated for d3 v4
}
//makemap
const makemap = (geojson) => {
  	let path = g.selectAll('path').data(geojson)
								.enter().append('path')
  							.attr('d',pathGenerator)
  //zoomToBoundingBox
  const zoomToBoundingBox = d => {
  let bounds = pathGenerator.bounds(d),
      dx = bounds[1][0] - bounds[0][0],
      dy = bounds[1][1] - bounds[0][1],
      x = (bounds[0][0] + bounds[1][0]) / 2,
      y = (bounds[0][1] + bounds[1][1]) / 2,
      scale = Math.max(1, Math.min(8, 0.9 / Math.max(dx / width, dy / height))),
      translate = [width / 2 - scale * x, height / 2 - scale * y];
    svg.transition().duration(transitionDuration).call(
  	zzoom.transform, d3.zoomIdentity.translate(translate[0],translate[1]).scale(scale)
    ); 
    
  }
	const clicked = d =>{
     if (active.node() === this) return reset();
  active.classed("active", false);
  active = d3.select(this).classed("active", true);
  //clicked
  zoomToBoundingBox(d);
	let selectedBlock = d.properties.Block;
  let selectedjson = selectMap(geojson,selectedBlock);
  g.selectAll("*").remove();
  makemap(selectedjson)
	}

  path.on('click',clicked)
}

//selectmap
const selectMap = (geojson,location) => {
  		let selection = [];
  		geojson.forEach( sel =>{
      	if (sel.properties.Block == location){
        	selection.push(sel);
        }
      });
  		return selection;
}
d3.json('project.json').then(json =>{
  makemap(json.features)
  d3.select('button').on('click',function(){
  g.selectAll("*").remove();
  svg.transition().duration(transitionDuration).call( zzoom.transform, d3.zoomIdentity );
  makemap(json.features);
})
})

 